/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"

GtkWidget*
create_mainwin ()
{
  GtkWidget *mainwin;
  GtkWidget *vbox1;
  GtkWidget *filemenu;
  GtkWidget *item1;
  GtkWidget *item1_menu;
  GtkAccelGroup *item1_menu_accels;
  GtkWidget *gamequit;
  GtkWidget *frame1;
  GtkWidget *frame1_menu;
  GtkAccelGroup *frame1_menu_accels;
  GtkWidget *f1_1;
  GtkWidget *f1_5;
  GtkWidget *f1_10;
  GtkWidget *f1_15;
  GtkWidget *f1_20;
  GtkWidget *f1_30;
  GtkWidget *balls1;
  GtkWidget *balls1_menu;
  GtkAccelGroup *balls1_menu_accels;
  GtkWidget *b10;
  GtkWidget *b20;
  GtkWidget *b50;
  GtkWidget *b100;
  GtkWidget *b200;
  GtkWidget *b400;
  GtkWidget *b500;
  GtkWidget *transparent1;
  GtkWidget *transparent1_menu;
  GtkAccelGroup *transparent1_menu_accels;
  GtkWidget *yes1;
  GtkWidget *no1;
  GtkWidget *drawingarea1;
  GtkWidget *statusbar1;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  mainwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (mainwin, "mainwin");
  gtk_object_set_data (GTK_OBJECT (mainwin), "mainwin", mainwin);
  gtk_widget_set_usize (mainwin, 640, 528);
  gtk_widget_set_events (mainwin, GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK | GDK_KEY_PRESS_MASK);
  gtk_window_set_title (GTK_WINDOW (mainwin), "sprite sample");
  gtk_window_set_policy (GTK_WINDOW (mainwin), FALSE, FALSE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (mainwin), vbox1);

  filemenu = gtk_menu_bar_new ();
  gtk_widget_set_name (filemenu, "filemenu");
  gtk_widget_ref (filemenu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "filemenu", filemenu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (filemenu);
  gtk_box_pack_start (GTK_BOX (vbox1), filemenu, FALSE, FALSE, 0);
  gtk_menu_bar_set_shadow_type (GTK_MENU_BAR (filemenu), GTK_SHADOW_ETCHED_IN);

  item1 = gtk_menu_item_new_with_label ("File");
  gtk_widget_set_name (item1, "item1");
  gtk_widget_ref (item1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "item1", item1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (item1);
  gtk_container_add (GTK_CONTAINER (filemenu), item1);

  item1_menu = gtk_menu_new ();
  gtk_widget_set_name (item1_menu, "item1_menu");
  gtk_widget_ref (item1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "item1_menu", item1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (item1), item1_menu);
  item1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (item1_menu));

  gamequit = gtk_menu_item_new_with_label ("quit");
  gtk_widget_set_name (gamequit, "gamequit");
  gtk_widget_ref (gamequit);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "gamequit", gamequit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (gamequit);
  gtk_container_add (GTK_CONTAINER (item1_menu), gamequit);
  gtk_widget_add_accelerator (gamequit, "activate", accel_group,
                              GDK_Q, GDK_CONTROL_MASK | GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  frame1 = gtk_menu_item_new_with_label ("Frame");
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_container_add (GTK_CONTAINER (filemenu), frame1);

  frame1_menu = gtk_menu_new ();
  gtk_widget_set_name (frame1_menu, "frame1_menu");
  gtk_widget_ref (frame1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "frame1_menu", frame1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (frame1), frame1_menu);
  frame1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (frame1_menu));

  f1_1 = gtk_menu_item_new_with_label ("1/1");
  gtk_widget_set_name (f1_1, "f1_1");
  gtk_widget_ref (f1_1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "f1_1", f1_1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (f1_1);
  gtk_container_add (GTK_CONTAINER (frame1_menu), f1_1);

  f1_5 = gtk_menu_item_new_with_label ("1/5");
  gtk_widget_set_name (f1_5, "f1_5");
  gtk_widget_ref (f1_5);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "f1_5", f1_5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (f1_5);
  gtk_container_add (GTK_CONTAINER (frame1_menu), f1_5);

  f1_10 = gtk_menu_item_new_with_label ("1/10");
  gtk_widget_set_name (f1_10, "f1_10");
  gtk_widget_ref (f1_10);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "f1_10", f1_10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (f1_10);
  gtk_container_add (GTK_CONTAINER (frame1_menu), f1_10);

  f1_15 = gtk_menu_item_new_with_label ("1/15");
  gtk_widget_set_name (f1_15, "f1_15");
  gtk_widget_ref (f1_15);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "f1_15", f1_15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (f1_15);
  gtk_container_add (GTK_CONTAINER (frame1_menu), f1_15);

  f1_20 = gtk_menu_item_new_with_label ("1/20");
  gtk_widget_set_name (f1_20, "f1_20");
  gtk_widget_ref (f1_20);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "f1_20", f1_20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (f1_20);
  gtk_container_add (GTK_CONTAINER (frame1_menu), f1_20);

  f1_30 = gtk_menu_item_new_with_label ("1/30");
  gtk_widget_set_name (f1_30, "f1_30");
  gtk_widget_ref (f1_30);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "f1_30", f1_30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (f1_30);
  gtk_container_add (GTK_CONTAINER (frame1_menu), f1_30);

  balls1 = gtk_menu_item_new_with_label ("Balls");
  gtk_widget_set_name (balls1, "balls1");
  gtk_widget_ref (balls1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "balls1", balls1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (balls1);
  gtk_container_add (GTK_CONTAINER (filemenu), balls1);

  balls1_menu = gtk_menu_new ();
  gtk_widget_set_name (balls1_menu, "balls1_menu");
  gtk_widget_ref (balls1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "balls1_menu", balls1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (balls1), balls1_menu);
  balls1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (balls1_menu));

  b10 = gtk_menu_item_new_with_label ("10");
  gtk_widget_set_name (b10, "b10");
  gtk_widget_ref (b10);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "b10", b10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b10);
  gtk_container_add (GTK_CONTAINER (balls1_menu), b10);

  b20 = gtk_menu_item_new_with_label ("20");
  gtk_widget_set_name (b20, "b20");
  gtk_widget_ref (b20);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "b20", b20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b20);
  gtk_container_add (GTK_CONTAINER (balls1_menu), b20);

  b50 = gtk_menu_item_new_with_label ("50");
  gtk_widget_set_name (b50, "b50");
  gtk_widget_ref (b50);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "b50", b50,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b50);
  gtk_container_add (GTK_CONTAINER (balls1_menu), b50);

  b100 = gtk_menu_item_new_with_label ("100");
  gtk_widget_set_name (b100, "b100");
  gtk_widget_ref (b100);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "b100", b100,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b100);
  gtk_container_add (GTK_CONTAINER (balls1_menu), b100);

  b200 = gtk_menu_item_new_with_label ("200");
  gtk_widget_set_name (b200, "b200");
  gtk_widget_ref (b200);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "b200", b200,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b200);
  gtk_container_add (GTK_CONTAINER (balls1_menu), b200);

  b400 = gtk_menu_item_new_with_label ("400");
  gtk_widget_set_name (b400, "b400");
  gtk_widget_ref (b400);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "b400", b400,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b400);
  gtk_container_add (GTK_CONTAINER (balls1_menu), b400);

  b500 = gtk_menu_item_new_with_label ("500");
  gtk_widget_set_name (b500, "b500");
  gtk_widget_ref (b500);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "b500", b500,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b500);
  gtk_container_add (GTK_CONTAINER (balls1_menu), b500);

  transparent1 = gtk_menu_item_new_with_label ("Transparent");
  gtk_widget_set_name (transparent1, "transparent1");
  gtk_widget_ref (transparent1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "transparent1", transparent1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (transparent1);
  gtk_container_add (GTK_CONTAINER (filemenu), transparent1);

  transparent1_menu = gtk_menu_new ();
  gtk_widget_set_name (transparent1_menu, "transparent1_menu");
  gtk_widget_ref (transparent1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "transparent1_menu", transparent1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (transparent1), transparent1_menu);
  transparent1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (transparent1_menu));

  yes1 = gtk_menu_item_new_with_label ("Yes");
  gtk_widget_set_name (yes1, "yes1");
  gtk_widget_ref (yes1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "yes1", yes1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (yes1);
  gtk_container_add (GTK_CONTAINER (transparent1_menu), yes1);

  no1 = gtk_menu_item_new_with_label ("No");
  gtk_widget_set_name (no1, "no1");
  gtk_widget_ref (no1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "no1", no1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (no1);
  gtk_container_add (GTK_CONTAINER (transparent1_menu), no1);

  drawingarea1 = gtk_drawing_area_new ();
  gtk_widget_set_name (drawingarea1, "drawingarea1");
  gtk_widget_ref (drawingarea1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "drawingarea1", drawingarea1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawingarea1);
  gtk_box_pack_start (GTK_BOX (vbox1), drawingarea1, TRUE, TRUE, 0);

  statusbar1 = gtk_statusbar_new ();
  gtk_widget_set_name (statusbar1, "statusbar1");
  gtk_widget_ref (statusbar1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "statusbar1", statusbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar1);
  gtk_box_pack_end (GTK_BOX (vbox1), statusbar1, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (mainwin), "destroy",
                      GTK_SIGNAL_FUNC (on_mainwin_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (item1), "activate",
                      GTK_SIGNAL_FUNC (on_item1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (gamequit), "activate",
                      GTK_SIGNAL_FUNC (on_gamequit_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (frame1), "activate",
                      GTK_SIGNAL_FUNC (on_frame1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (f1_1), "activate",
                      GTK_SIGNAL_FUNC (on_f1_1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (f1_5), "activate",
                      GTK_SIGNAL_FUNC (on_f1_5_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (f1_10), "activate",
                      GTK_SIGNAL_FUNC (on_f1_10_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (f1_15), "activate",
                      GTK_SIGNAL_FUNC (on_f1_15_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (f1_20), "activate",
                      GTK_SIGNAL_FUNC (on_f1_20_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (f1_30), "activate",
                      GTK_SIGNAL_FUNC (on_f1_30_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (balls1), "activate",
                      GTK_SIGNAL_FUNC (on_balls1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (b10), "activate",
                      GTK_SIGNAL_FUNC (on_b10_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (b20), "activate",
                      GTK_SIGNAL_FUNC (on_b20_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (b50), "activate",
                      GTK_SIGNAL_FUNC (on_b50_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (b100), "activate",
                      GTK_SIGNAL_FUNC (on_b100_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (b200), "activate",
                      GTK_SIGNAL_FUNC (on_b200_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (b400), "activate",
                      GTK_SIGNAL_FUNC (on_b400_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (b500), "activate",
                      GTK_SIGNAL_FUNC (on_b500_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (yes1), "activate",
                      GTK_SIGNAL_FUNC (on_yes1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (no1), "activate",
                      GTK_SIGNAL_FUNC (on_no1_activate),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (mainwin), accel_group);

  return mainwin;
}

