/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - ᥤ롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Oct.23.1999  Programing start (sprite sample)
  Jan.20.2000  sprite sample part 2

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit       -- ᥤץʤ
  RRMain           -- ֤˥뤵ᥤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk_imlib.h>
#include  "rr_main.h"
#include  "rr_screen.h"
#include  "rr_spriteman.h"

#include  "ball.xpm"
#include  "back.xpm"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/*--- local timer */
gint timer, lap;
time_t segment;

/* --- ǥץ쥤ݻ */
gint  fw, fh;

/* --- ¸ѥץ饤ȥե졼Хåե */
GdkPixmap  *smap, *backpix;
GdkBitmap  *smask;

/* --- ¸ */
gboolean   trans;
gint       ball_max;
gint       int_handle;

/* --- ץ饤ȥ */
#define    BALLNUM  50
#define    BALLMAX  1000
RRSObj     *balls[BALLMAX], *bg;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  gint i;

  timer = 0;
  lap = 0;
  trans = TRUE;
  ball_max = 10;
  int_handle = 0;
  segment = time(NULL);
  RRScreenFontSetInit("-adobe-times-bold-r-normal-*-26-*-*-*-*-*-*-*,\
            -misc-fixed-medium-*-normal-*-24-*-*-*-*-*-jisx0208.1983-0");

  /* -- ߳ */
  interval_set(10);

  RRScreenClear(0, 0, 0x6000);

  /* -- եå pixmap  */
  smap = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
				      &smask,
				      NULL,
				      ball_xpm);

  backpix = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
					 NULL,
					 NULL,
					 back_xpm);

  /* -- ֥ */
  RRSpritemanInit();
  RRSpritemanBGColor(0x0000, 0x0000, 0x6000);

  for(i=0; i<BALLMAX; i++) {
    balls[i] = NULL;
  }

  bg = RRSpritemanBGNew();
  bg->obj.sw = TRUE;
  bg->obj.mask_offset = TRUE;
  bg->obj.objmap = backpix;
  bg->obj.objmask = NULL;
  bg->obj.x = bg->obj.y = 0;
  bg->obj.w = 640;
  bg->obj.h = 480;
  bg->obj.ox = bg->obj.oy = 0;
  bg->obj.offset_x = bg->obj.offset_y = 0;
  RRScreenObjPut(&(bg->obj));

  RRMainBall(BALLNUM);
}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (smap != NULL) gdk_pixmap_unref(smap);
  if (smask != NULL) gdk_bitmap_unref(smask);
  if (backpix != NULL) gdk_pixmap_unref(backpix);
  RRSpritemanFree();
}


/* -------------------------------------------------------------
  RRMainWindowSize   -- եå

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowSize(gint w, gint h)
{
  fw = w;
  fh = h;
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  RRSprite   *obj;
  GtkStatusbar *stat;
  gchar tmp[128], info[128];
  gint  o1, o2, i;

  timer++;
  lap++;
  if (segment != time(NULL)) {
    segment = time(NULL);
    /* --- StatusBar ˾ɽ */
    stat = GTK_STATUSBAR(RRGetParts(RRGetParts(RRScreenWindow(), "vbox1"), "statusbar1"));
    sprintf(info, "frame %d/Sec.", lap);
    gtk_statusbar_push(stat, gtk_statusbar_get_context_id(stat, tmp), info);
    lap = 0;
  }
//return 1;

  /* --- Graphic Buffer Υå */
  RRScreenSwitch();

  /* --- ե졼 */
//  RRScreenClear(0, 0, 0x6000);


  for(i=0; i<ball_max; i++) {
    obj = &(balls[i]->obj);
    o1 = i* 273;
    o2 = i * 111;
    obj->sw = TRUE;
    obj->mask_offset = TRUE;
    obj->objmap = smap;
    if (trans == TRUE) {
      obj->objmask = smask;
    }
    else {
      obj->objmask = NULL;
    }
    if (1) {
      obj->x = ((timer + o1) % 640);
      obj->y = ((timer + o2) % 480);
    }
    else {
      obj->x = ( o1 % 640);
      obj->y = ( o2 % 480);
    }
    if (obj->x > 320) obj->x = 640 - obj->x;
    if (obj->y > 240) obj->y = 480 - obj->y;
    obj->x *= 2;
    obj->y *= 2;
    obj->w = obj->h = 32;
    obj->ox = (i % 2) * 32;
    obj->oy = ((i % 4) / 2) * 32;
    obj->offset_x = obj->offset_y = 15;
  }
  RRSpritemanAutoUpdate(0);

  return 1;
}



/* -------------------------------------------------------------
    --- ˥塼μ
-------------------------------------------------------------- */
void RRMainTransparent(gboolean sw)
{
  trans = sw;
}
void RRMainBall(gint n)
{
  gint i;

  ball_max = n;

  RRScreenObjPut(&(bg->obj));
  for(i=0; i<BALLMAX; i++) {
    if (balls[i] != NULL) {
      RRSpritemanDestroy(balls[i]);
    }
  }
  for(i=0; i<ball_max; i++) {
    balls[i] = RRSpritemanNew();
    balls[i]->z = i;
  }
}

void interval_set(gint n)
{
#if 1
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  int_handle = gtk_timeout_add(1000/n, (GtkFunction)RRMain, NULL);
#else
  if (int_handle != 0) gtk_idle_remove(int_handle);
  int_handle = gtk_idle_add((GtkFunction)RRMain, NULL);
#endif
}


